searchData={"items":[{"type":"task","title":"mix tenex.gen.migration","doc":"Generates a migration.\n\nThe repository must be set under `:ecto_repos` in the\ncurrent app configuration or given via the `-r` option.","ref":"Mix.Tasks.Tenex.Gen.Migration.html"},{"type":"task","title":"Examples - mix tenex.gen.migration","doc":"mix tenex.gen.migration add_posts_table\n    mix tenex.gen.migration add_posts_table -r Custom.Repo\n\nBy default, the migration will be generated to the\n\"priv/YOUR_REPO/migrations\" directory of the current application\nbut it can be configured to be any subdirectory of `priv` by\nspecifying the `:priv` key under the repository configuration.\n\nThis generator will automatically open the generated file if\nyou have `ECTO_EDITOR` set in your environment variable.","ref":"Mix.Tasks.Tenex.Gen.Migration.html#module-examples"},{"type":"task","title":"Command line options - mix tenex.gen.migration","doc":"* `-r`, `--repo` - the repo to generate migration for","ref":"Mix.Tasks.Tenex.Gen.Migration.html#module-command-line-options"},{"type":"task","title":"PS - mix tenex.gen.migration","doc":"All of this code is copied from `mix ecto.gen.migration` task, if something\ndoes not work, please compare them and try to stay as close to it as possible.","ref":"Mix.Tasks.Tenex.Gen.Migration.html#module-ps"},{"type":"task","title":"mix tenex.migrate","doc":"Runs the pending tenant migrations for the given repository.\n\nTenant migrations are expected at \"priv/YOUR_REPO/tenant_migrations\" directory\nof the current application, where \"YOUR_REPO\" is the last segment\nin your repository name. For example, the repository `MyApp.Repo`\nwill use \"priv/repo/tenant_migrations\". The repository `Whatever.MyRepo`\nwill use \"priv/my_repo/tenant_migrations\".\n\nYou can configure a repository to use another directory by specifying\nthe `:priv` key under the repository configuration. The \"tenant_migrations\"\npart will be automatically appended to it. For instance, to use\n\"priv/custom_repo/tenant_migrations\":\n\n    config :my_app, MyApp.Repo, priv: \"priv/custom_repo\"\n\nTo change the \"tenant_migrations\" part, you can set the `:migrations_path`\nconfig under tenex configuration. For example, to use \"priv/repo/my_migrations\":\n\n    config :tenex, migrations_path: \"my_migrations\"\n\nThis task runs all pending tenant migrations by default. To migrate up to a\nspecific version number, supply `--to version_number`. To migrate a\nspecific number of times, use `--step n`.\n\nThe repositories to migrate are the ones specified under the\n`:ecto_repos` option in the current app configuration. However,\nif the `-r` option is given, it replaces the `:ecto_repos` config.\n\nSince Ecto tasks can only be executed once, if you need to migrate\nmultiple repositories, set `:ecto_repos` accordingly or pass the `-r`\nflag multiple times.\n\nIf a repository has not yet been started, one will be started outside\nyour application supervision tree and shutdown afterwards.","ref":"Mix.Tasks.Tenex.Migrate.html"},{"type":"task","title":"Examples - mix tenex.migrate","doc":"mix ecto.migrate\n    mix ecto.migrate -r Custom.Repo\n\n    mix ecto.migrate -n 3\n    mix ecto.migrate --step 3\n\n    mix ecto.migrate -v 20080906120000\n    mix ecto.migrate --to 20080906120000","ref":"Mix.Tasks.Tenex.Migrate.html#module-examples"},{"type":"task","title":"Command line options - mix tenex.migrate","doc":"* `-r`, `--repo` - the repo to migrate\n  * `--all` - run all pending migrations\n  * `--step` / `-n` - run n number of pending migrations\n  * `--to` - run all migrations up to and including version\n  * `--quiet` - do not log migration commands\n  * `--pool-size` - the pool size if the repository is started only for the task (defaults to 1)\n  * `--log-sql` - log the raw sql migrations are running\n  * `--strict-version-order` - abort when applying a migration with old timestamp\n  * `--no-compile` - does not compile applications before migrating\n  * `--no-deps-check` - does not check dependencies before migrating","ref":"Mix.Tasks.Tenex.Migrate.html#module-command-line-options"},{"type":"task","title":"PS - mix tenex.migrate","doc":"All of this code is copied from `mix ecto.migrate` task, if something does\nnot work, please compare them and try to stay as close to it as possible.","ref":"Mix.Tasks.Tenex.Migrate.html#module-ps"},{"type":"task","title":"mix tenex.migrations","doc":"Displays the up / down migration status for the given repository.\n\nThe repository must be set under `:ecto_repos` in the\ncurrent app configuration or given via the `-r` option.\n\nBy default, migrations are expected at \"priv/YOUR_REPO/migrations\"\ndirectory of the current application but it can be configured\nby specifying the `:priv` key under the repository configuration.\n\nIf the repository has not been started yet, one will be\nstarted outside our application supervision tree and shutdown\nafterwards.","ref":"Mix.Tasks.Tenex.Migrations.html"},{"type":"task","title":"Examples - mix tenex.migrations","doc":"mix tenex.migrations\n    mix tenex.migrations -r Custom.Repo","ref":"Mix.Tasks.Tenex.Migrations.html#module-examples"},{"type":"task","title":"Command line options - mix tenex.migrations","doc":"* `-r`, `--repo` - the repo to obtain the status for","ref":"Mix.Tasks.Tenex.Migrations.html#module-command-line-options"},{"type":"task","title":"mix tenex.rollback","doc":"Reverts applied migrations in the given repository.\n\nTenant migrations are expected at \"priv/YOUR_REPO/tenant_migrations\" directory\nof the current application, where \"YOUR_REPO\" is the last segment\nin your repository name. For example, the repository `MyApp.Repo`\nwill use \"priv/repo/tenant_migrations\". The repository `Whatever.MyRepo`\nwill use \"priv/my_repo/tenant_migrations\".\n\nYou can configure a repository to use another directory by specifying\nthe `:priv` key under the repository configuration. The \"migrations\"\npart will be automatically appended to it. For instance, to use\n\"priv/custom_repo/migrations\":\n\n    config :my_app, MyApp.Repo, priv: \"priv/custom_repo\"\n\nTo change the \"tenant_migrations\" part, you can set the `:migrations_path`\nconfig under tenex configuration. For example, to use \"priv/repo/my_migrations\":\n\n    config :tenex, migrations_path: \"my_migrations\"\n\nThis task runs all pending migrations by default. Runs the last\napplied migration by default. To roll back to a version number,\nsupply `--to version_number`. To roll back a specific number of\ntimes, use `--step n`. To undo all applied migrations, provide\n`--all`.\n\nThe repositories to rollback are the ones specified under the\n`:ecto_repos` option in the current app configuration. However,\nif the `-r` option is given, it replaces the `:ecto_repos` config.\n\nIf a repository has not yet been started, one will be started outside\nyour application supervision tree and shutdown afterwards.","ref":"Mix.Tasks.Tenex.Rollback.html"},{"type":"task","title":"Examples - mix tenex.rollback","doc":"mix ecto.rollback\n    mix ecto.rollback -r Custom.Repo\n\n    mix ecto.rollback -n 3\n    mix ecto.rollback --step 3\n\n    mix ecto.rollback --to 20080906120000","ref":"Mix.Tasks.Tenex.Rollback.html#module-examples"},{"type":"task","title":"Command line options - mix tenex.rollback","doc":"* `-r`, `--repo` - the repo to rollback\n  * `--all` - revert all applied migrations\n  * `--step` / `-n` - revert n number of applied migrations\n  * `--to` - revert all migrations down to and including version\n  * `--quiet` - do not log migration commands\n  * `--pool-size` - the pool size if the repository is started only for the task (defaults to 1)\n  * `--log-sql` - log the raw sql migrations are running\n  * `--no-compile` - does not compile applications before rolling back\n  * `--no-deps-check` - does not check dependencies before rolling back","ref":"Mix.Tasks.Tenex.Rollback.html#module-command-line-options"},{"type":"task","title":"PS - mix tenex.rollback","doc":"All of this code is copied from `mix ecto.rollback` task, if something does\nnot work, please compare them and try to stay as close to it as possible.","ref":"Mix.Tasks.Tenex.Rollback.html#module-ps"},{"type":"module","title":"Mix.Tenex","doc":"Useful functions for any tenex mix task.\n\nHere is the list of tasks we have for now:\n\n- [`mix tenex.gen.migration`](./Mix.Tasks.Tenex.Gen.Migration.html) -\ngenerates a tenant migration for the repo\n- [`mix tenex.migrate`](./Mix.Tasks.Tenex.Migrate.html) -\nruns the repository tenant migrations\n- [`mix tenex.migrations`](./Mix.Tasks.Tenex.Migrations.html) -\ndisplays the repository migration status\n- [`mix tenex.rollback`](./Mix.Tasks.Tenex.Rollback.html) -\nrolls back the repository tenant migrations","ref":"Mix.Tenex.html"},{"type":"function","title":"Mix.Tenex.ensure_started/2","doc":"Ensures the given repository is started and running.","ref":"Mix.Tenex.html#ensure_started/2"},{"type":"function","title":"Mix.Tenex.ensure_tenant_migrations_path/1","doc":"Ensures the migrations path exists for the given `repo`.\n\nReturns the path for the `repo` tenant migrations folder if succeeds\nor `Mix.raise`'s if it fails.","ref":"Mix.Tenex.html#ensure_tenant_migrations_path/1"},{"type":"function","title":"Mix.Tenex.restart_apps_if_migrated/2","doc":"Restarts the app if there was any migration command.","ref":"Mix.Tenex.html#restart_apps_if_migrated/2"},{"type":"function","title":"Mix.Tenex.run_tenant_migrations/3","doc":"Runs the tenant migrations with the given `args` and using\n`migrator` function.","ref":"Mix.Tenex.html#run_tenant_migrations/3"},{"type":"function","title":"Mix.Tenex.source_repo_priv/1","doc":"Returns the private repository path relative to the source.","ref":"Mix.Tenex.html#source_repo_priv/1"},{"type":"module","title":"Tenex","doc":"This is the main module of Tenex.\n\nThe main objective of it is to make a little bit easier to manage tenants\nthrough postgres db schemas, executing queries and commands\ninside and outside the tenant without much boilerplate code.","ref":"Tenex.html"},{"type":"module","title":"Using the tenant - Tenex","doc":"This module has useful functions to manage your tenants, like `create/1`,\n`rename/2` and `drop/1`, but if you're trying to apply the tenant to a\nquery, changeset or schema, stay with your application `Repo`, sending the\nprefix. Like this:\n\n    Repo.all(User, prefix: Tenex.to_prefix(\"my_tenant\"))\n\nIt's a good idea to call `Tenex.to_prefix` on your tenant name, although is\nnot required. Because, if you configured a `tenant_prefix`, this function will\nreturn the prefixed one.","ref":"Tenex.html#module-using-the-tenant"},{"type":"function","title":"Tenex.all/2","doc":"Returns all the tenants on the given `repo`.","ref":"Tenex.html#all/2"},{"type":"function","title":"Tenex.config/0","doc":"Returns a `%Tenex.Config{}` struct with all the args loaded from the app\nconfiguration.","ref":"Tenex.html#config/0"},{"type":"function","title":"Tenex.create/2","doc":"Creates the given `tenant` on the given `repo`.\n\nReturns `{:ok, tenant}` if successful or `{:error, reason}` otherwise.\n\nBesides creating the database itself, this function also loads their\nstructure executing all migrations from inside\n`priv/YOUR_REPO/tenant_migrations` folder. By calling `create_schema/3`\nsending `migrate/2` as the `func` callback.\n\nSee `migrate/2` for more details about the migration running.","ref":"Tenex.html#create/2"},{"type":"function","title":"Ecto 3 migrations, tenex and transactions - Tenex.create/2","doc":"So on Ecto 3, migrations were changed to run on async tasks. Because of\nthat it's not possible anymore to run `Tenex.create/2` inside of a\ntransaction anymore.\n\nBut there is a way to achieve the same results using `create_schema/3`\nand `migrate/2`. Here is an example using transaction:\n\n    Repo.transaction(fn ->\n      {:ok, _} = Tenex.create(\"tenant\")\n      User.insert!(%{name: \"Demo user 1\"})\n      User.insert!(%{name: \"Demo user 2\"})\n    end)\n\nAnd here is how you could achieve the same results on success or fail:\n\n    Tenex.create_schema(\"tenant\", Repo, fn(tenant, repo) ->\n      Repo.transaction(fn ->\n        {:ok, _} = Tenex.migrate(tenant, repo)\n        User.insert!(%{name: \"Demo user 1\"})\n        User.insert!(%{name: \"Demo user 2\"})\n\n        # the `create_schema/3` function must return `{:ok, \"tenant\"}`\n        # if succeeded, and `Repo.transaction` transforms the function results\n        # on this tuple\n        tenant\n      end)\n    end)\n\nSo, if the function given to `create_schema/3` returns an error tuple, it will\nrollback the created schema and return that tuple to you. Check out\n`create_schema/3` docs for more details.","ref":"Tenex.html#create/2-ecto-3-migrations-tenex-and-transactions"},{"type":"function","title":"Tenex.create_schema/3","doc":"Creates the `tenant` schema/database on the given `repo`.\n\nReturns `{:ok, tenant}` if successful or `{:error, reason}` otherwise.\n\nAfter creating it successfully, the given `func` callback is called with\nthe `tenant` and the `repo` as arguments. The `func` must return\n`{:ok, any}` if successful or `{:error, reason}` otherwise. In the case\nthe `func` fails, this func will rollback the created schema and\nfail with the same `reason`.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenex.html#create_schema/3"},{"type":"function","title":"Tenex.drop/2","doc":"Drops the given tenant on the given `repo`.\n\nReturns `{:ok, tenant}` if successful or `{:error, reason}` otherwise.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenex.html#drop/2"},{"type":"function","title":"Tenex.exists?/2","doc":"Returns if the given `tenant` exists or not on the given `repo`.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenex.html#exists?/2"},{"type":"function","title":"Tenex.migrate/2","doc":"Migrates the given `tenant` on your `repo`.\n\nReturns `{:ok, migrated_versions}` if successful or `{:error, reason}` otherwise.\n\nThe function `to_prefix/1` will be applied to the `tenant`.","ref":"Tenex.html#migrate/2"},{"type":"function","title":"Tenex.migrations_path/1","doc":"Returns the path for the tenant migrations on your `repo`.","ref":"Tenex.html#migrations_path/1"},{"type":"function","title":"Tenex.rename/3","doc":"Renames the `old_tenant` to the `new_tenant` on the given `repo`.\n\nReturns `{:ok, new_tenant}` if successful or `{:error, reason}` otherwise.\n\nThe function `to_prefix/1` will be applied to the `old_tenant` and\n`new_tenant`.","ref":"Tenex.html#rename/3"},{"type":"function","title":"Tenex.reserved_tenant?/1","doc":"Returns if the given `tenant` is reserved or not.\n\nThe function `to_prefix/1` will be applied to the tenant.","ref":"Tenex.html#reserved_tenant?/1"},{"type":"function","title":"Tenex.reserved_tenants/0","doc":"Returns the list of reserved tenants.\n\nBy default, there are some limitations for the name of a tenant depending on\nthe database, like \"public\" or anything that start with \"pg_\".\n\nYou also can configure your own reserved tenant names if you want with:\n\n    config :tenex, reserved_tenants: [\"www\", \"api\", ~r/^db+$/]\n\nNotice that you can use regexes, and they will be applied to the tenant\nnames.","ref":"Tenex.html#reserved_tenants/0"},{"type":"function","title":"Tenex.tenant_field/1","doc":"Returns the value of the configured tenant field on the given `map`.","ref":"Tenex.html#tenant_field/1"},{"type":"function","title":"Tenex.to_prefix/2","doc":"Returns the `tenant` name with the given `prefix`.\n\nIf the `prefix` is omitted, the `tenant_prefix` configuration from\n`Tenex.Config` will be used.\n\nThe `tenant` can be a string, a map or a struct. For a string it will\nbe used as the tenant name to concat the prefix. For a map or a struct, it\nwill get the `tenant_field/0` from it to concat the prefix.","ref":"Tenex.html#to_prefix/2"},{"type":"module","title":"Tenex.Config","doc":"All the configuration for `Tenex` basic functionality is here:\n\n- `repo`: the ecto repo that will be used to execute the schema operations.\n- `tenant_prefix`: a prefix for all tenants.\n- `reserved_tenants`: a list of reserved tenants, which cannot be created\nthrough tenex APIs. The items here can be strings or regexes.\n- `tenant_field`: an atom with the name of the field to get the tenant name\nif the given tenant is a struct. By default it's `:id`.","ref":"Tenex.Config.html"},{"type":"module","title":"Tenex.EnsurePlug","doc":"This is a basic plug that ensure the tenant is loaded.\n\nTo plug it on your router, you can use:\n\n    plug Tenex.EnsurePlug,\n      callback: &TenantHelper.callback/2\n      failure_callback: &TenantHelper.failure_callback/2\n\nSee `Tenex.EnsurePlugConfig` to check all the allowed `config` flags.","ref":"Tenex.EnsurePlug.html"},{"type":"module","title":"Tenex.EnsurePlugConfig","doc":"This is a struct that holds the configuration for `Tenex.EnsurePlug`.\n\nHere are the config keys allowed:\n\n- `assign`: the name of the assign where we must save the tenant.\n- `callback`: function that might be called when the plug succeeded. It\nmust return a connection.\n- `failure_callback`: function that might be called when the plug failed.\nIt must return a connection.","ref":"Tenex.EnsurePlugConfig.html"},{"type":"module","title":"Tenex.ParamPlug","doc":"This is a basic plug that loads the current tenant assign from a given\nparam.\n\nTo plug it on your router, you can use:\n\n    plug Tenex.ParamPlug,\n      param: :subdomain,\n      tenant_handler: &TenantHelper.tenant_handler/1\n\nSee `Tenex.ParamPlugConfig` to check all the allowed `config` flags.","ref":"Tenex.ParamPlug.html"},{"type":"module","title":"Tenex.ParamPlugConfig","doc":"This is a struct that holds all configuration for `Tenex.ParamPlug`.\n\nHere are the config keys allowed:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.\n- `param`: the param name to load the tenant from.","ref":"Tenex.ParamPlugConfig.html"},{"type":"module","title":"Tenex.Plug","doc":"This module have some basic functions for our tenex plugs.\n\nThe plugs we have for now are:\n\n- `Tenex.ParamPlug` - loads the tenant from a body or query param\n- `Tenex.SessionPlug` - loads the tenant from a session param\n- `Tenex.SubdomainPlug` - loads the tenant from the url subdomain\n- `Tenex.EnsurePlug` - ensures the current tenant is loaded and halts if not","ref":"Tenex.Plug.html"},{"type":"function","title":"Tenex.Plug.ensure_tenant/2","doc":"Ensure the tenant is loaded, and if not, halts the `conn`.\n\nThe `config` map/struct must have:\n\n- `assign`: the name of the assign where we must save the tenant.","ref":"Tenex.Plug.html#ensure_tenant/2"},{"type":"function","title":"Tenex.Plug.put_tenant/3","doc":"Puts the given `tenant` as an assign on the given `conn`, but only if the\ntenant is not reserved.\n\nThe `config` map/struct must have:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.","ref":"Tenex.Plug.html#put_tenant/3"},{"type":"module","title":"Tenex.SessionPlug","doc":"This is a basic plug that loads the current tenant assign from a given\nvalue set on session.\n\nTo plug it on your router, you can use:\n\n    plug Tenex.SessionPlug,\n      session: :subdomain,\n      tenant_handler: &TenantHelper.tenant_handler/1\n\nSee `Tenex.SessionPlugConfig` to check all the allowed `config` flags.","ref":"Tenex.SessionPlug.html"},{"type":"module","title":"Tenex.SessionPlugConfig","doc":"This is a struct that holds the configuration for `Tenex.SessionPlug`.\n\nHere are the config keys allowed:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.\n- `session`: the session param name to load the tenant from.","ref":"Tenex.SessionPlugConfig.html"},{"type":"module","title":"Tenex.SubdomainPlug","doc":"This is a basic plug that loads the current tenant assign from a given\nvalue set on subdomain.\n\nTo plug it on your router, you can use:\n\n    plug Tenex.SubdomainPlug,\n      endpoint: MyApp.Endpoint,\n      tenant_handler: &TenantHelper.tenant_handler/1\n\nSee `Tenex.SubdomainPlugConfig` to check all the allowed `config` flags.","ref":"Tenex.SubdomainPlug.html"},{"type":"module","title":"Tenex.SubdomainPlugConfig","doc":"This is a struct that holds the configuration for `Tenex.SubdomainPlug`.\n\nHere are the config keys allowed:\n\n- `tenant_handler`: function to handle the tenant param. Its return will\nbe used as the tenant.\n- `assign`: the name of the assign where we must save the tenant.\n- `endpoint`: the Phoenix.Endpoint to get the host name to discover the\nsubdomain.","ref":"Tenex.SubdomainPlugConfig.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n## [1.0.3](https://github.com/augustwenty/tenex/compare/v1.0.2...v1.0.3) (2025-03-11)","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* adding 'md' file extension back after accidental deletion ([f0f73b7](https://github.com/augustwenty/tenex/commit/f0f73b7f0a93801e8fc89473e5d0092b0616f96e))\n* adding workflows for project/package ([707efcc](https://github.com/augustwenty/tenex/commit/707efccd2b70a10665de9508b05a529bf452aa7c))\n* adding workflows for project/package ([f90a7e7](https://github.com/augustwenty/tenex/commit/f90a7e700ff595a4c6e1bb5e969f5adeb0af9254))\n* fixing version for proper deployment ([396b0a0](https://github.com/augustwenty/tenex/commit/396b0a0e3d38f902e379e99ba9acad4414741961))\n* fixing version for proper deployment ([0d2943a](https://github.com/augustwenty/tenex/commit/0d2943a047dfc82ba0d99d0fce12720991eb1b71))\n* formatting issue ([d95f398](https://github.com/augustwenty/tenex/commit/d95f3987c5b0bab7e0f4cdef760ad207de676529))\n* invalid formatting ([be6b286](https://github.com/augustwenty/tenex/commit/be6b28686cf002e362506b0293152302e1f5cedc))\n* more clean up ([57bc960](https://github.com/augustwenty/tenex/commit/57bc96026ddbcf6ec58b85d188e45f96f80e6e34))\n* updated THANKS section in order to communicate the conversion to a ([38460f3](https://github.com/augustwenty/tenex/commit/38460f3ce96d97e035b44a86da187baf19f36ed0))\n* updated THANKS section in order to communicate the conversion to a new package ([f0cef45](https://github.com/augustwenty/tenex/commit/f0cef455c6e6755f670fb2c80a267202bc65cd6c))","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.0.2 - Changelog","doc":"","ref":"changelog.html#1-0-2"},{"type":"extras","title":"allows the user to turn off logging of sql queries - Changelog","doc":"","ref":"changelog.html#allows-the-user-to-turn-off-logging-of-sql-queries"},{"type":"extras","title":"Changed - Changelog","doc":"- lib/tenex.ex","ref":"changelog.html#changed"},{"type":"extras","title":"Breaking changes - Changelog","doc":"n/a","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"1.0.1 - Changelog","doc":"","ref":"changelog.html#1-0-1"},{"type":"extras","title":"README updates/clean-up - Changelog","doc":"","ref":"changelog.html#readme-updates-clean-up"},{"type":"extras","title":"Changed - Changelog","doc":"- README.md","ref":"changelog.html#changed"},{"type":"extras","title":"Breaking changes - Changelog","doc":"n/a","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"1.0.0 - Changelog","doc":"","ref":"changelog.html#1-0-0"},{"type":"extras","title":"Resetting the repo for new ownership - Changelog","doc":"- fix: first check-in after pull from original repo\n- fix: removing case statements no longer required because I am only supporting postgres\n- fix: clean up work\n- fix: renaming to Tenex\n- fix: updating packages\n- fix: updating ownership naming","ref":"changelog.html#resetting-the-repo-for-new-ownership"},{"type":"extras","title":"Changed - Changelog","doc":"too many to list, please check the actual PR for files changed","ref":"changelog.html#changed"},{"type":"extras","title":"Breaking changes - Changelog","doc":"n/a","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Contributing","doc":"# Contributing\n\nHere is a step by step for contributing to the project:\n\n- Fork the project\n- Create a branch for your feature/fix\n- Make it happen\n- Create tests for it\n- Make sure to run `mix format`\n- Also, give `mix credo` a check, we enforce no warning on CI build\n- Don't forget to add the changes you made to `CHANGELOG.md`\n- Open a PR\n- Wait for review!","ref":"contributing.html"},{"type":"extras","title":"Releasing - Contributing","doc":"Here is the step by step to release the project (team members only):\n\n- Change the `version` key on `mix.exs` to the version you'll release\n- Commit it to `master`\n- Make sure CI passes and docs are good\n- Prepare the version branch:\n  - If you're releasing a major or minor, open a branch for it, with a naming like `1.0`\n  - If you're releasing a patch with all the things on master, checkout the minor branch and\n  `git rebase master` on it\n  - If you're releasing a patch, but can't get everything of master, `git cherry-pick  ` of\n  every commit you need, adapt if needed and push it\n- Create a draft for your release on Github\n  - From branch: `1.0`\n  - Tag: `v1.0.0`\n  - Release name: `1.0.0`\n  - Description: exactly the same as changelog\n- Run `mix hex.publish`\n- Submit your release draft\n- Update `README.md` version","ref":"contributing.html#releasing"},{"type":"extras","title":"Code of Conduct","doc":"# Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"1. Be Respectful - Code of Conduct","doc":"Respect all contributors, users, and maintainers. Everyone should feel welcome and valued in this community.","ref":"code_of_conduct.html#1-be-respectful"},{"type":"extras","title":"2. Be Inclusive - Code of Conduct","doc":"We strive to create an inclusive and diverse environment. Discrimination, harassment, or exclusionary behavior will not be tolerated.","ref":"code_of_conduct.html#2-be-inclusive"},{"type":"extras","title":"3. Be Constructive - Code of Conduct","doc":"Offer helpful and constructive feedback. Criticism should be aimed at ideas, not people.","ref":"code_of_conduct.html#3-be-constructive"},{"type":"extras","title":"4. No Harassment - Code of Conduct","doc":"Harassment, abuse, or personal attacks of any kind are not allowed.","ref":"code_of_conduct.html#4-no-harassment"},{"type":"extras","title":"5. Follow the Rules - Code of Conduct","doc":"Follow the project’s guidelines, licensing rules, and contribution policies.","ref":"code_of_conduct.html#5-follow-the-rules"},{"type":"extras","title":"6. Report Issues - Code of Conduct","doc":"If you experience or witness inappropriate behavior, report it to the project maintainers.","ref":"code_of_conduct.html#6-report-issues"},{"type":"extras","title":"7. Have Fun! - Code of Conduct","doc":"We’re all here to collaborate, learn, and build something great together.","ref":"code_of_conduct.html#7-have-fun"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2025 augustwenty\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Tenex\n\n[![Version](http://img.shields.io/hexpm/v/tenex.svg?style=flat)](https://hex.pm/packages/tenex)\n[![Downloads](https://img.shields.io/hexpm/dt/tenex.svg)](https://hex.pm/packages/tenex)\n[![Coverage Status](https://coveralls.io/repos/github/augustwenty/tenex/badge.svg?branch=master)](https://coveralls.io/github/augustwenty/tenex?branch=master)\n\nA simple and effective way to build multitenant applications on top of Ecto.\n\n[Documentation](https://hexdocs.pm/tenex/readme.html)\n\nTenex leverages database data segregation techniques (such as [Postgres schemas](https://www.postgresql.org/docs/current/static/ddl-schemas.html)) to keep tenant-specific data separated, while allowing you to continue using the Ecto functions you are familiar with.","ref":"readme.html"},{"type":"extras","title":"Quick Start - Overview","doc":"1. Add `tenex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:tenex, \"~> 1.0.0\"},\n  ]\nend\n```\n\n2. Run in your shell:\n\n```bash\nmix deps.get\n```","ref":"readme.html#quick-start"},{"type":"extras","title":"Configuration - Overview","doc":"Configure the Repo you will use to execute the database commands within your config/config.exs file:\n\n    config :tenex, repo: ExampleApp.Repo","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - Overview","doc":"Here is a quick overview of what you can do with tenex!","ref":"readme.html#usage"},{"type":"extras","title":"Creating, renaming and dropping tenants - Overview","doc":"#### To create a new tenant:\n\n```elixir\nTenex.create(\"your_tenant\")\n```\n\nThis will create a new database schema and run your migrations — which may take a while depending on your application.\n\n#### Rename a tenant:\n\n```elixir\nTenex.rename(\"your_tenant\", \"my_tenant\")\n```\n\nThis is not something you should need to do often. :-)\n\n#### Delete a tenant:\n\n```elixir\nTenex.drop(\"my_tenant\")\n```\n\nMore information on the API can be found in [documentation](https://hexdocs.pm/tenex/Tenex.html#content).","ref":"readme.html#creating-renaming-and-dropping-tenants"},{"type":"extras","title":"Creating tenant migrations - Overview","doc":"To create a migration to run across tenant schemas:\n\n```bash\nmix tenex.gen.migration your_migration_name\n```\n\nIf migrating an existing project to use Tenex, you can move some or all of your existing migrations from `priv/YOUR_REPO/migrations` to `priv/YOUR_REPO/tenant_migrations`.\n\nTenex and Ecto will automatically add prefixes to standard migration functions. If you have _custom_ SQL in your migrations, you will need to use the [`prefix`](https://hexdocs.pm/ecto/Ecto.Migration.html#prefix/0) function provided by Ecto. e.g.\n\n```elixir\ndef up do\n  execute \"CREATE INDEX name_trgm_index ON #{prefix()}.users USING gin (nam gin_trgm_ops);\"\nend\n```","ref":"readme.html#creating-tenant-migrations"},{"type":"extras","title":"Running tenant migrations: - Overview","doc":"```bash\nmix tenex.migrate\n```\n\nThis will migrate all of your existing tenants, one by one. In the case of failure, the next run will continue from where it stopped.","ref":"readme.html#running-tenant-migrations"},{"type":"extras","title":"Using Ecto - Overview","doc":"Your Ecto usage only needs the `prefix` option. Tenex provides a helper to coerce the tenant value into the proper format, e.g.:\n\n```elixir\nRepo.all(User, prefix: Tenex.to_prefix(\"my_tenant\"))\nRepo.get!(User, 123, prefix: Tenex.to_prefix(\"my_tenant\"))\n```","ref":"readme.html#using-ecto"},{"type":"extras","title":"Fetching the tenant with Plug - Overview","doc":"Tenex includes configurable plugs that you can use to load the current tenant in your application.\n\nHere is an example loading the tenant from the current subdomain:\n\n```elixir\nplug Tenex.SubdomainPlug, endpoint: MyApp.Endpoint\n```\n\nFor more information, check the `Tenex.Plug` documentation for an overview of our plugs.","ref":"readme.html#fetching-the-tenant-with-plug"},{"type":"extras","title":"Thanks - Overview","doc":"This library was originally inspired by the [Triplex](https://hex.pm/packages/triplex) hex package, which provided multi-tenancy support for\nElixir applications. However, Triplex is no longer being actively maintained, with no updates since 2019.\nTo address this, we have taken the original Triplex package, applied the outstanding pull requests, and\nintroduced a new version under the name Tenex. This ensures continued improvements and support for those\nrelying on a robust multi-tenancy solution in Elixir. Additionally, we have removed support for MySQL,\nfocusing solely on databases that better align with our vision for Tenex\nand ensuring a more maintainable and optimized experience.","ref":"readme.html#thanks"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}